#!/usr/bin/python2.7.17
# -*-coding:Latin-1 -*
from heapq import heappush, heappop, heapify
from collections import defaultdict
from bitarray import bitarray
import itertools

textAEncoder = "saperlipopette"
dict_frequence = defaultdict(int)
#On parcours le dictionnaire pour compter la fréquence d'apparition
#de chaque caractère
for caractere in textAEncoder:
    dict_frequence[caractere] += 1;

print(dict_frequence)


#On créé une liste de liste (arbre) qui contient la fréquence
#ainsi que le caractere et l'encodage de chaque caractere (attribué plus tard)
arbre = [[freq, [caractere, ""]] for caractere, freq, in dict_frequence.items()]
print(arbre)
#ici, la commande heapify restructure sous forme de "vrai arbre"
heapify(arbre)
print(arbre)

#Attribution de l'encodage des différents caractères...
#on ignore le premier element car il correspond à la fréquence d'apparition
while len(arbre) > 1:
    droite = heappop(arbre) #prend le plus petit element de arbre
    gauche = heappop(arbre)

    #On attribue 0 à droite
    for paire in droite[:1]:
        paire[1] = '0' + paire[1]
    #On attribue 1 à gauche
    for paire in gauche[:1]:
        paire[1] = '1' + paire[1]
    #On ajoute les encodages attribués à arbre
    heappush(arbre, [droite[0] + gauche[0]] + droite[1:] + gauche[:1]);
print(arbre)

huffman = droite[1:] + gauche[1:]
# huffman_arrayByte = []
print(huffman)
# for i in range(len(huffman)):
#     huffman_arrayByte[i-1] = itertools.islice(huffman, 8)
dict_huffman = {a[0]:bitarray(str(a[0])) for a in huffman}
texte_encode = bitarray()
texte_encode.encode(dict_huffman, textAEncoder)
print(texte_encode)
with open('output.bin', wb) as file:
    texte_encode.tofile(file)
